Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/interp.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/interp.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/interp.f90	(revision 5213)
@@ -8,19 +8,73 @@
 !> @brief 
 !> This module manage interpolation on regular grid.
-!> @note It is used to work on ORCA grid, as we work only with grid indices.
+!>
+!> @details Interpolation method to be used is specify inside variable 
+!>    strcuture, as array of string character.<br/> 
+!>    - td_var\%c_interp(1) string character is the interpolation name choose between:
+!>       - 'nearest'
+!>       - 'cubic  '
+!>       - 'linear '
+!>    - td_var\%c_interp(2) string character is an operation to be used 
+!>    on interpolated value.<br/>
+!>          operation have to be mulitplication '*' or division '/'.<br/>
+!>          coefficient have to be refinement factor following i-direction 'rhoi', 
+!>          j-direction 'rhoj', or k-direction 'rhok'.<br/>
+!>
+!>          Examples: '*rhoi', '/rhoj'.
+!> 
+!>    @note Those informations are read from namelist or variable configuration file (default).<br/>
+!>    Interplation method could be specify for each variable in namelist _namvar_,
+!>    defining string character _cn\_varinfo_.<br/>
+!>    Example:
+!>       - cn_varinfo='varname1:cubic/rhoi', 'varname2:linear' 
+!>
+!>    to create mixed grid (with coarse grid point needed to compute
+!> interpolation):<br/>
+!> @code
+!>    CALL interp_create_mixed_grid( td_var, td_mix [,id_rho] )
+!> @endcode
+!>       - td_var is coarse grid variable (should be extrapolated)
+!>       - td_mix is mixed grid variable structure [output]
+!>       - id_rho is array of refinment factor [optional]
+!>
+!>    to detected point to be interpolated:<br/>
+!> @code
+!>    il_detect(:,:,:)=interp_detect( td_mix [,id_rho] )
+!> @endcode
+!>       - il_detect(:,:,:) is 3D array of detected point to be interpolated
+!>       - td_mix is mixed grid variable
+!>       - id_rho is array of refinement factor [optional]
+!>
+!>    to interpolate variable value:<br/>
+!> @code
+!>    CALL  interp_fill_value( td_var [,id_rho] [,id_offset] )
+!> @endcode
+!>       - td_var is variable structure
+!>       - id_rho is array of refinement factor [optional]
+!>       - id_offset is array of offset between fine and coarse grid [optional]
+!>
+!>    to clean mixed grid (remove points added on mixed grid to compute interpolation):<br/>
+!> @code
+!>    CALL interp_clean_mixed_grid( td_mix, td_var, id_rho )
+!> @endcode
+!>       - td_mix is mixed grid variable structure
+!>       - td_var is variable structure [output]
+!>       - id_rho is array of refinement factor [optional]
+!>       - id_offset is array of offset between fine and coarse grid [optional]
+!>
+!> @note It use to work on ORCA grid, as we work only with grid indices.
 !>
 !> @warning due to the use of second derivative when using cubic interpolation
-!> you should add 2 extrabands
+!> you should add at least 2 extrabands.
 !>
-!> @details
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
+!> @date November, 2013 - Initial Version
+!> @date September, 2014
+!> - add header
+!> - use interpolation method modules
+!>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
-!> - interp 3D
-!> - see issue when fill value is zero for check cubic_fill..
 !----------------------------------------------------------------------
 MODULE interp
@@ -29,22 +83,17 @@
    USE global                          ! global variable
    USE kind                            ! F90 kind parameter
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE fct                             ! basic useful function
-!   USE date                            ! date manager
+   USE date                            ! date manager
    USE att                             ! attribute manager
    USE dim                             ! dimension manager
    USE var                             ! variable manager
-!   USE file                            ! file manager
-!   USE iom                             ! I/O manager
-!   USE dom                             ! domain manager
    USE grid                            ! grid manager
    USE extrap                          ! extrapolation manager
-!   USE interp                          ! interpolation manager
-!   USE filter                          ! filter manager
-!   USE mpp                             ! MPP manager
-!   USE iom_mpp                         ! MPP I/O manager
+   USE interp_cubic                    !   cubic interpolation manager
+   USE interp_linear                   !  linear interpolation manager
+   USE interp_nearest                  ! nearest interpolation manager
 
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
@@ -53,34 +102,16 @@
    ! function and subroutine
    PUBLIC :: interp_detect             !< detected point to be interpolated
-   PUBLIC :: interp_fill_value         !< interpolate value over detectected point
+   PUBLIC :: interp_fill_value         !< interpolate value
    PUBLIC :: interp_create_mixed_grid  !< create mixed grid
    PUBLIC :: interp_clean_mixed_grid   !< clean mixed grid
 
-   PRIVATE :: interp__detect           !< detected point to be interpolated
-   PRIVATE :: interp__detect_wrapper   !< detected point to be interpolated
-   PRIVATE :: interp__fill_value_wrapper !< interpolate value over detectected point
-   PRIVATE :: interp__fill_value       !< interpolate value over detectected point
-   PRIVATE :: interp__clean_even_grid  !< clean even mixed grid
-   PRIVATE :: interp__del_offset       !< remove offset from interpolated grid
-   PRIVATE :: interp__check_method     !< check if interpolation method available
-!   PRIVATE :: interp__3D               !< interpolate 3D grid
-   PRIVATE :: interp__2D               !< interpolate 2D grid
-   PRIVATE :: interp__1D               !< interpolate 1D grid 
-   PRIVATE :: interp__2D_cubic_coef    !< compute coefficient for bicubic interpolation 
-   PRIVATE :: interp__2D_cubic_fill    !< compute bicubic interpolation 
-   PRIVATE :: interp__2D_linear_coef   !< compute coefficient for bilinear interpolation
-   PRIVATE :: interp__2D_linear_fill   !< compute bilinear interpolation 
-   PRIVATE :: interp__2D_nearest_fill  !< compute nearest interpolation 
-   PRIVATE :: interp__1D_cubic_coef    !< compute coefficient for cubic interpolation 
-   PRIVATE :: interp__1D_cubic_fill    !< compute cubic interpolation 
-   PRIVATE :: interp__1D_linear_coef   !< compute coefficient for linear interpolation
-   PRIVATE :: interp__1D_linear_fill   !< compute linear interpolation 
-   PRIVATE :: interp__1D_nearest_fill  !< compute nearest interpolation 
-!   PRIVATE :: interp__longitude
+   PRIVATE :: interp__detect              ! detected point to be interpolated
+   PRIVATE :: interp__detect_wrapper      ! detected point to be interpolated
+   PRIVATE :: interp__fill_value_wrapper  ! interpolate value over detectected point
+   PRIVATE :: interp__fill_value          ! interpolate value over detectected point
+   PRIVATE :: interp__clean_even_grid     ! clean even mixed grid
+   PRIVATE :: interp__check_method        ! check if interpolation method available
    
    TYPE TINTERP
-      !CHARACTER(LEN=lc) :: c_name = 'unknown'   !< interpolation method name
-      !CHARACTER(LEN=lc) :: c_factor = 'unknown' !< interpolation factor
-      !CHARACTER(LEN=lc) :: c_divisor = 'unknown'   !< interpolation divisor
       CHARACTER(LEN=lc) :: c_name   = '' !< interpolation method name
       CHARACTER(LEN=lc) :: c_factor = '' !< interpolation factor
@@ -89,9 +120,9 @@
 
    INTERFACE interp_detect
-      MODULE PROCEDURE interp__detect_wrapper !< detected point to be interpolated
+      MODULE PROCEDURE interp__detect_wrapper 
    END INTERFACE interp_detect
 
    INTERFACE interp_fill_value
-      MODULE PROCEDURE interp__fill_value_wrapper !< detected point to be interpolated
+      MODULE PROCEDURE interp__fill_value_wrapper 
    END INTERFACE interp_fill_value
 
@@ -99,16 +130,16 @@
    !-------------------------------------------------------------------
    !> @brief
-   !> This function check if interpolation method available.
+   !> This function check if interpolation method is available.
    !> 
    !> @details 
+   !> check if name of interpolation method is present in global list of string
+   !> character cp_interp_list (see global.f90).
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] cd_method : interpolation method
+   !> @param[in] cd_method interpolation method
    !> @return 
-   !> @todo see extrap_detect
-   !-------------------------------------------------------------------
-   !> @code
+   !-------------------------------------------------------------------
    FUNCTION interp__check_method( cd_method )
       IMPLICIT NONE
@@ -130,6 +161,6 @@
 
       interp__check_method=.FALSE.
-      DO ji=1,ig_ninterp
-         cl_interp=fct_lower(cg_interp_list(ji))
+      DO ji=1,ip_ninterp
+         cl_interp=fct_lower(cp_interp_list(ji))
          IF( TRIM(cl_interp) == TRIM(cl_method) )THEN
             interp__check_method=.TRUE.
@@ -139,5 +170,4 @@
 
    END FUNCTION interp__check_method
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -149,11 +179,10 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mix : mixed grid variable (to interpolate)
-   !> @param[in] id_rho : table of refinement factor
-   !> @return table of detected point to be interpolated 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] td_mix mixed grid variable (to interpolate)
+   !> @param[in] id_rho array of refinement factor
+   !> @return 3D array of detected point to be interpolated 
+   !-------------------------------------------------------------------
    FUNCTION interp__detect_wrapper( td_mix, id_rho )
       IMPLICIT NONE
@@ -168,5 +197,4 @@
 
       ! local variable
-
       ! loop indices
       !----------------------------------------------------------------
@@ -208,5 +236,4 @@
 
    END FUNCTION interp__detect_wrapper
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -217,11 +244,10 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] td_mix : mixed grid variable (to interpolate)
-   !> @param[in] id_rho : table of refinement factor
-   !> @return table of detected point to be interpolated 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] td_mix mixed grid variable (to interpolate)
+   !> @param[in] id_rho array of refinement factor
+   !> @return 3D array of detected point to be interpolated 
+   !-------------------------------------------------------------------
    FUNCTION interp__detect( td_mix, id_rho )
       IMPLICIT NONE
@@ -253,5 +279,5 @@
       ALLOCATE( il_rho(ip_maxdim) )
       il_rho(:)=1
-      IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
+      IF( PRESENT(id_rho) ) il_rho(1:SIZE(id_rho(:)))=id_rho(:)
 
       ! special case for even refinement on ARAKAWA-C grid
@@ -289,4 +315,5 @@
       il_dim(:)=td_mix%t_dim(1:3)%i_len
 
+      ! init
       interp__detect(:,:,:)=1
 
@@ -297,26 +324,32 @@
 
       ! do not compute point near fill value
-      FORALL( ji=1:il_dim(1):il_rho(jp_I), &
-      &       jj=1:il_dim(2):il_rho(jp_J), &
-      &       jk=1:il_dim(3):il_rho(jp_K), &
-      &       td_mix%d_value(ji,jj,jk,1) == td_mix%d_fill )
-
-         ! i-direction
-         interp__detect(MAX(1,ji-il_xextra):MIN(ji+il_xextra,il_dim(1)),&
-         &              MAX(1,jj-(il_rho(jp_J)-1)):MIN(jj+(il_rho(jp_J)-1),il_dim(2)),&
-         &              MAX(1,jk-(il_rho(jp_K)-1)):MIN(jk+(il_rho(jp_K)-1),il_dim(3)) )=0 
-         ! j-direction
-         interp__detect(MAX(1,ji-(il_rho(jp_I)-1)):MIN(ji+(il_rho(jp_I)-1),il_dim(1)),&
-         &              MAX(1,jj-il_yextra):MIN(jj+il_yextra,il_dim(2)),&
-         &              MAX(1,jk-(il_rho(jp_K)-1)):MIN(jk+(il_rho(jp_K)-1),il_dim(3)) )=0
-         ! k-direction
-         interp__detect(MAX(1,ji-(il_rho(jp_I)-1)):MIN(ji+(il_rho(jp_I)-1),il_dim(1)),&
-         &              MAX(1,jj-(il_rho(jp_J)-1)):MIN(jj+(il_rho(jp_J)-1),il_dim(2)),&
-         &              MAX(1,jk-il_zextra):MIN(jk+il_zextra,il_dim(3)) )=0         
-
-      END FORALL
+      DO jk=1,il_dim(3),il_rho(jp_K)
+         DO jj=1,il_dim(2),il_rho(jp_J)
+            DO ji=1,il_dim(1),il_rho(jp_I)
+
+               IF( td_mix%d_value(ji,jj,jk,1) == td_mix%d_fill )THEN
+
+                  ! i-direction
+                  interp__detect(MAX(1,ji-il_xextra):MIN(ji+il_xextra,il_dim(1)),&
+                  &              MAX(1,jj-(il_rho(jp_J)-1)):MIN(jj+(il_rho(jp_J)-1),il_dim(2)),&
+                  &              MAX(1,jk-(il_rho(jp_K)-1)):MIN(jk+(il_rho(jp_K)-1),il_dim(3)) )=0 
+                  ! j-direction
+                  interp__detect(MAX(1,ji-(il_rho(jp_I)-1)):MIN(ji+(il_rho(jp_I)-1),il_dim(1)),&
+                  &              MAX(1,jj-il_yextra):MIN(jj+il_yextra,il_dim(2)),&
+                  &              MAX(1,jk-(il_rho(jp_K)-1)):MIN(jk+(il_rho(jp_K)-1),il_dim(3)) )=0
+                  ! k-direction
+                  interp__detect(MAX(1,ji-(il_rho(jp_I)-1)):MIN(ji+(il_rho(jp_I)-1),il_dim(1)),&
+                  &              MAX(1,jj-(il_rho(jp_J)-1)):MIN(jj+(il_rho(jp_J)-1),il_dim(2)),&
+                  &              MAX(1,jk-il_zextra):MIN(jk+il_zextra,il_dim(3)) )=0         
+
+               ENDIF
+
+            ENDDO
+         ENDDO
+      ENDDO
+
+      DEALLOCATE( il_rho )
 
    END FUNCTION interp__detect
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -330,13 +363,10 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : coarse grid variable (should be extrapolated)
-   !> @param[out] td_mix : mixed grid variable
-   !> @param[in] id_rho  : table of refinment factor 
-   !>
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] td_var    coarse grid variable (should be extrapolated)
+   !> @param[out] td_mix   mixed grid variable
+   !> @param[in] id_rho    array of refinment factor (default 1) 
+   !-------------------------------------------------------------------
    SUBROUTINE interp_create_mixed_grid( td_var, td_mix, id_rho )
       IMPLICIT NONE
@@ -359,5 +389,5 @@
       ALLOCATE(il_rho(ip_maxdim))
       il_rho(:)=1
-      IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
+      IF( PRESENT(id_rho) ) il_rho(1:SIZE(id_rho(:)))=id_rho(:)
 
       ! special case for even refinement on ARAKAWA-C grid
@@ -381,5 +411,5 @@
 
       ! copy variable
-      td_mix=td_var
+      td_mix=var_copy(td_var)
 
       ! compute new dimension length
@@ -408,6 +438,7 @@
       &     td_var%d_value(:,:,:,:)
 
+      DEALLOCATE(il_rho)
+
    END SUBROUTINE interp_create_mixed_grid
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -418,16 +449,13 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in]  td_mix : mixed grid variable
-   !> @param[in] id_rho  : table of refinment factor 
-   !>
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_mix mixed grid variable
+   !> @param[in] id_rho    array of refinment factor 
+   !-------------------------------------------------------------------
    SUBROUTINE interp__clean_even_grid( td_mix, id_rho )
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(INOUT) :: td_mix 
+      TYPE(TVAR) ,               INTENT(INOUT) :: td_mix 
       INTEGER(I4), DIMENSION(:), INTENT(IN   ), OPTIONAL :: id_rho
 
@@ -468,9 +496,9 @@
       END SELECT
 
-      ! copy variable
-      tl_mix=td_mix
-
       ! remove some point only if refinement in some direction is even
       IF( ANY(ll_even(:)) )THEN
+
+         ! copy variable
+         tl_mix=var_copy(td_mix)
 
          ALLOCATE( ll_mask( tl_mix%t_dim(1)%i_len, &
@@ -554,5 +582,8 @@
 
             td_mix%d_value(:,:,:,:)=RESHAPE( dl_vect(:), &
-            &                                SHAPE=td_mix%t_dim(:)%i_len )
+            &                                SHAPE=(/td_mix%t_dim(1)%i_len, &
+            &                                        td_mix%t_dim(2)%i_len, &
+            &                                        td_mix%t_dim(3)%i_len, &
+            &                                        td_mix%t_dim(4)%i_len/) )
 
             DEALLOCATE( dl_vect )
@@ -562,35 +593,38 @@
          DEALLOCATE( ll_mask )
 
+         ! clean
+         CALL var_clean(tl_mix)
+
       ENDIF
 
-      CALL var_clean(tl_mix)
+      ! clean
+      DEALLOCATE(il_rho)
 
    END SUBROUTINE interp__clean_even_grid
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine save interpolated value over domain. 
-   !> And so remove points added on mixed grid 
-   !> to compute interpolation
+   !> This subroutine remove points added on mixed grid 
+   !> to compute interpolation. And save interpolated value over domain. 
    !> 
    !> @details 
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : table of mixed grid variable (to interpolate)
-   !> @param[in] id_rho : table of refinement factor
-   !> @return 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use offset to save useful domain
+   !>
+   !> @param[in] td_mix    mixed grid variable structure
+   !> @param[out] td_var   variable structure
+   !> @param[in] id_rho    array of refinement factor (default 1)
+   !> @param[in] id_offset 2D array of offset between fine and coarse grid
+   !-------------------------------------------------------------------
    SUBROUTINE interp_clean_mixed_grid( td_mix, td_var, &
-   &                                   id_rho, &
-   &                                   id_offset )
+   &                                   id_rho, id_offset )
       IMPLICIT NONE
       ! Argument
       TYPE(TVAR)                 , INTENT(IN   ) :: td_mix
       TYPE(TVAR)                 , INTENT(  OUT) :: td_var
-      INTEGER(I4), DIMENSION(:)  , INTENT(IN   ), OPTIONAL :: id_rho
-      INTEGER(I4), DIMENSION(:,:), INTENT(IN   ), OPTIONAL :: id_offset
+      INTEGER(I4), DIMENSION(:)  , INTENT(IN   ) :: id_rho
+      INTEGER(I4), DIMENSION(2,2), INTENT(IN   ) :: id_offset
 
       ! local variable
@@ -605,6 +639,4 @@
       INTEGER(i4) :: il_jmax1
 
-      INTEGER(i4), DIMENSION(2,2) :: il_offset
-
       REAL(dp), DIMENSION(:,:,:,:) , ALLOCATABLE :: dl_value
 
@@ -613,15 +645,6 @@
       ! loop indices
       !----------------------------------------------------------------
-      il_offset(:,:)=0 
-      IF( PRESENT(id_offset) )THEN
-         IF( ANY( SHAPE(id_offset(:,:)) /= SHAPE(il_offset(:,:)) ) )THEN
-            CALL logger_error("INTERP CLEAN MIXED GRID: invalid dimension of"//&
-            &                 " offset table")
-         ELSE
-            il_offset(:,:)=id_offset(:,:)
-         ENDIF
-      ENDIF
       ! copy mixed variable in temporary structure
-      tl_mix=td_mix
+      tl_mix=var_copy(td_mix)
 
       ! remove unusefull points over mixed grid for even refinement
@@ -629,131 +652,62 @@
 
       ! copy cleaned mixed variable
-      td_var=tl_mix
-      IF( ALL(td_var%t_dim(1:2)%l_use) )THEN
-
-         ! delete table of value
-         CALL var_del_value(td_var)
-
-         ! compute domain indices
-         il_imin0=1  ; il_imax0=td_var%t_dim(1)%i_len
-         il_jmin0=1  ; il_jmax0=td_var%t_dim(2)%i_len
-   
-         il_imin1=il_imin0+il_offset(1,1)
-         il_jmin1=il_jmin0+il_offset(2,1)
-   
-         il_imax1=il_imax0-il_offset(1,2)
-         il_jmax1=il_jmax0-il_offset(2,2)
-
-         SELECT CASE(TRIM(td_var%c_point))
-         CASE('U')
-            il_imin1=il_imin0+(il_offset(1,1)-1)
-            il_imax1=il_imax0-(il_offset(1,2)+1)
-         CASE('V')
-            il_jmin1=il_jmin0+(il_offset(2,1)-1)
-            il_jmax1=il_jmax0-(il_offset(2,2)+1)
-         CASE('F')
-            il_imin1=il_imin0+(il_offset(1,1)-1)
-            il_imax1=il_imax0-(il_offset(1,2)+1)
-
-            il_jmin1=il_jmin0+(il_offset(2,1)-1)
-            il_jmax1=il_jmax0-(il_offset(2,2)+1)
-         END SELECT
-
-         ! compute new dimension
-         td_var%t_dim(1)%i_len=il_imax1-il_imin1+1
-         td_var%t_dim(2)%i_len=il_jmax1-il_jmin1+1
+      td_var=var_copy(tl_mix)
+
+      ! delete array of value
+      CALL var_del_value(td_var)
+
+      ! compute domain indices in i-direction
+      il_imin0=1  ; il_imax0=td_var%t_dim(1)%i_len
  
-         ALLOCATE(dl_value(td_var%t_dim(1)%i_len, &
-         &                 td_var%t_dim(2)%i_len, &
-         &                 td_var%t_dim(3)%i_len, &
-         &                 td_var%t_dim(4)%i_len) )
-
-         dl_value( 1:td_var%t_dim(1)%i_len, &
-         &         :,:,:) = tl_mix%d_value( il_imin1:il_imax1, &
-         &                                  il_jmin1:il_jmax1, &
-         &                                      :, : )
-
-         ! add variable value
-         CALL var_add_value(td_var,dl_value(:,:,:,:))
-
-         ! save variable type
-         td_var%i_type=tl_mix%i_type
-
-         DEALLOCATE(dl_value)
+      IF( td_var%t_dim(1)%l_use )THEN
+         il_imin1=il_imin0+id_offset(Jp_I,1)
+         il_imax1=il_imax0-id_offset(Jp_I,2)
+      ELSE
+
+         il_imin1=il_imin0
+         il_imax1=il_imax0
 
       ENDIF
-      
+
+      ! compute domain indices in j-direction
+      il_jmin0=1  ; il_jmax0=td_var%t_dim(2)%i_len
+ 
+      IF( td_var%t_dim(2)%l_use )THEN
+         il_jmin1=il_jmin0+id_offset(Jp_J,1)
+         il_jmax1=il_jmax0-id_offset(Jp_J,2)
+      ELSE
+
+         il_jmin1=il_jmin0
+         il_jmax1=il_jmax0
+ 
+      ENDIF
+
+      ! compute new dimension
+      td_var%t_dim(1)%i_len=il_imax1-il_imin1+1
+      td_var%t_dim(2)%i_len=il_jmax1-il_jmin1+1
+ 
+      ALLOCATE(dl_value(td_var%t_dim(1)%i_len, &
+      &                 td_var%t_dim(2)%i_len, &
+      &                 td_var%t_dim(3)%i_len, &
+      &                 td_var%t_dim(4)%i_len) )
+
+      dl_value( 1:td_var%t_dim(1)%i_len, &
+      &         1:td_var%t_dim(2)%i_len, &
+      &         :,:) = tl_mix%d_value( il_imin1:il_imax1, &
+      &                                il_jmin1:il_jmax1, &
+      &                                     :, : )
+
+      ! add variable value
+      CALL var_add_value(td_var,dl_value(:,:,:,:))
+
+      DEALLOCATE(dl_value)
+ 
+      ! clean
       CALL var_clean(tl_mix)
 
    END SUBROUTINE interp_clean_mixed_grid
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine save interpolated value over domain. 
-   !> And so remove points added on mixed grid 
-   !> to compute interpolation
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : table of mixed grid variable (to interpolate)
-   !> @param[in] id_offset : table of offset
-   !> @return 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE interp__del_offset( td_var, id_offset )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TVAR)                 , INTENT(INOUT) :: td_var
-      INTEGER(i4), DIMENSION(:,:), INTENT(IN   ) :: id_offset
-
-      ! local variable
-      INTEGER(i4) :: il_imin1
-      INTEGER(i4) :: il_jmin1
-      INTEGER(i4) :: il_imax1
-      INTEGER(i4) :: il_jmax1
-
-      REAL(dp), DIMENSION(:,:,:,:) , ALLOCATABLE :: dl_value
-
-      ! loop indices
-      !----------------------------------------------------------------
-   
-      IF( ALL(td_var%t_dim(1:2)%l_use) )THEN
-
-         il_imin1=1+id_offset(1,1)
-         il_jmin1=1+id_offset(2,1)
-
-         il_imax1=td_var%t_dim(1)%i_len-id_offset(2,1)
-         il_jmax1=td_var%t_dim(2)%i_len-id_offset(2,2)
-
-         ! compute new dimension
-         td_var%t_dim(1)%i_len=il_imax1-il_imin1+1
-         td_var%t_dim(2)%i_len=il_jmax1-il_jmin1+1
-         ALLOCATE( dl_value( td_var%t_dim(1)%i_len, &
-         &                   td_var%t_dim(2)%i_len, &
-         &                   td_var%t_dim(3)%i_len, &
-         &                   td_var%t_dim(4)%i_len) )
-
-         dl_value(:,:,:,:)=td_var%d_value( il_imin1:il_imax1, &
-         &                                 il_jmin1:il_jmax1, &
-         &                                 :,: )
-
-         ! delete table of value
-         CALL var_del_value(td_var)
-
-         ! add variable value
-         CALL var_add_value(td_var,dl_value(:,:,:,:))
-
-         DEALLOCATE(dl_value)
-
-      ENDIF
-
-   END SUBROUTINE interp__del_offset
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief
-   !> This subroutine interpolate detected point.
+   !> This subroutine interpolate variable value.
    !> 
    !> @details 
@@ -762,10 +716,10 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : variable to be interpolated
-   !> @param[in] id_rho : table of refinement factor
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable structure
+   !> @param[in] id_rho    array of refinement factor
+   !> @param[in] id_offset 2D array of offset between fine and coarse grid
+   !-------------------------------------------------------------------
    SUBROUTINE interp__fill_value_wrapper( td_var, & 
    &                                      id_rho, &
@@ -774,30 +728,18 @@
       ! Argument
       TYPE(TVAR) ,                 INTENT(INOUT) :: td_var
-      INTEGER(I4), DIMENSION(:),   INTENT(IN   ), OPTIONAL :: id_rho
+      INTEGER(I4), DIMENSION(:)  , INTENT(IN   ), OPTIONAL :: id_rho
       INTEGER(I4), DIMENSION(:,:), INTENT(IN   ), OPTIONAL :: id_offset
 
       ! local variable
-      CHARACTER(LEN=lc)                 :: cl_method
-      INTEGER(i4)      , DIMENSION(:), ALLOCATABLE  :: il_rho
-      INTEGER(i4)      , DIMENSION(2,2) :: il_offset
+      CHARACTER(LEN=lc)                            :: cl_method
+      INTEGER(i4)      , DIMENSION(:), ALLOCATABLE :: il_rho
+      INTEGER(i4)      , DIMENSION(2,2)            :: il_offset
 
       ! loop indices
       !----------------------------------------------------------------
 
-      SELECT CASE(TRIM(td_var%c_interp(1)))
-         CASE('cubic','linear','nearest')
-            cl_method=TRIM(td_var%c_interp(1))
-         CASE DEFAULT
-            CALL logger_warn("INTERP FILL: interpolation method unknown."//&
-            &  " use linear interpolation")
-            cl_method='linear'
-
-            ! update variable structure value
-            td_var%c_interp(1)='linear'
-      END SELECT
-
       ALLOCATE( il_rho(ip_maxdim) )
       il_rho(:)=1
-      IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
+      IF( PRESENT(id_rho) ) il_rho(1:SIZE(id_rho(:)))=id_rho(:)
       IF( ANY(il_rho(:) < 0) )THEN
          CALL logger_error("INTERP FILL VALUE: invalid "//&
@@ -808,5 +750,5 @@
       IF( PRESENT(id_offset) )THEN
          IF( ANY(SHAPE(id_offset(:,:)) /= (/2,2/)) )THEN
-            CALL logger_error("INTERP FILL VALUE: invalid table of offset")
+            CALL logger_error("INTERP FILL VALUE: invalid array of offset")
          ELSE
             il_offset(:,:)=id_offset(:,:)
@@ -817,4 +759,15 @@
       &   (il_rho(jp_J) /= 1 .AND. td_var%t_dim(2)%l_use) .OR. &
       &   (il_rho(jp_K) /= 1 .AND. td_var%t_dim(3)%l_use) )THEN
+
+         SELECT CASE(TRIM(td_var%c_interp(1)))
+            CASE('cubic','linear','nearest')
+               cl_method=TRIM(td_var%c_interp(1))
+            CASE DEFAULT
+               CALL logger_warn("INTERP FILL VALUE: interpolation method unknown."//&
+               &  " use linear interpolation")
+               cl_method='linear'
+               ! update variable structure value
+               td_var%c_interp(1)='linear'
+         END SELECT
 
          CALL logger_info("INTERP FILL: interpolate "//TRIM(td_var%c_name)//&
@@ -826,6 +779,5 @@
  
          CALL interp__fill_value( td_var, cl_method, & 
-         &                        il_rho(:), &
-         &                        il_offset(:,:) )
+         &                        il_rho(:), il_offset(:,:) )
 
          SELECT CASE(TRIM(td_var%c_interp(2)))
@@ -864,26 +816,27 @@
          END SELECT
 
+      ELSE
+         td_var%c_interp(:)=''
       ENDIF
 
+      DEALLOCATE(il_rho)
+
    END SUBROUTINE interp__fill_value_wrapper
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This subroutine interpolate value over mixed grid.
    !> 
-   !> @details 
-   !> 
-   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable
-   !> @param[in] cd_method : interpolation method 
-   !> @param[in] id_rho : table of refinment factor 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use interpolation method modules
+   !>
+   !> @param[inout] td_var variable structure
+   !> @param[in] cd_method interpolation method 
+   !> @param[in] id_rho    array of refinment factor 
+   !> @param[in] id_offset 2D array of offset between fine and coarse grid
+   !-------------------------------------------------------------------
    SUBROUTINE interp__fill_value( td_var, cd_method, &
-   &                              id_rho, &
-   &                              id_offset )
+   &                              id_rho, id_offset )
       IMPLICIT NONE
       ! Argument
@@ -891,5 +844,5 @@
       CHARACTER(LEN=*)                , INTENT(IN   ) :: cd_method
       INTEGER(I4)     , DIMENSION(:)  , INTENT(IN   ) :: id_rho
-      INTEGER(I4)     , DIMENSION(:,:), INTENT(IN   ) :: id_offset
+      INTEGER(I4)     , DIMENSION(2,2), INTENT(IN   ) :: id_offset
 
       ! local variable
@@ -908,10 +861,6 @@
 
       TYPE(TATT)                                       :: tl_att
-
+ 
       ! loop indices
-      INTEGER(i4) :: ji
-      INTEGER(i4) :: jj
-      INTEGER(i4) :: jk
-      INTEGER(i4) :: jl
       !----------------------------------------------------------------
 
@@ -935,4 +884,7 @@
       tl_att=att_init('interpolation',cl_interp)
       CALL var_move_att(tl_mix, tl_att)
+
+      ! clean
+      CALL att_clean(tl_att)
 
       ! special case for even refinement on ARAKAWA-C grid
